{ fetchFromGitHub
, fetchYarnDeps
, runCommand
, nodejs
, yarn
, path
, nodePackages
}:
let
  pinData = import ../srcs/pin.nix;
  inherit (pinData) erpnextVersion;
  inherit (pinData.hashes) erpnextSrcHash;
  inherit (pinData.hashes) erpnextYarnHash;

  src = fetchFromGitHub {
    owner = "frappe";
    repo = "erpnext";
    rev = "v${erpnextVersion}";
    sha256 = erpnextSrcHash;
  };

  offlineCache = fetchYarnDeps {
    yarnLock = "${src}/yarn.lock";
    sha256 = erpnextYarnHash;
  };

  mkApp = import ./mk-app.nix {
    inherit path runCommand nodejs yarn nodePackages;
  };
in mkApp "erpnext" src offlineCache
