{ fetchFromGitHub
, fetchYarnDeps
, runCommand
, nodejs
, yarn
, path
, nodePackages
}:
let
  pinData = import ../srcs/pin.nix;
  inherit (pinData) frappeVersion;
  inherit (pinData.hashes) frappeSrcHash;
  inherit (pinData.hashes) frappeYarnHash;

  src = fetchFromGitHub {
    owner = "frappe";
    repo = "frappe";
    rev = "v${frappeVersion}";
    sha256 = frappeSrcHash;
  };

  offlineCache = fetchYarnDeps {
    yarnLock = "${src}/yarn.lock";
    sha256 = frappeYarnHash;
  };
  mkApp = import ./mk-app.nix {
    inherit path runCommand nodejs yarn nodePackages;
  };
in mkApp "frappe" src offlineCache
