{ lib
, buildPythonPackage
, fetchFromGitHub
, pythonRelaxDepsHook

, hatchling

, click
, gitpython
, honcho
, jinja2
, python-crontab
, requests
, semantic-version
, setuptools
, tomli
}:
let
  pinData = import ../srcs/pin.nix;
  inherit (pinData) benchVersion;
  inherit (pinData.hashes) benchSrcHash;
in
buildPythonPackage rec {
  pname = "frappe-bench";
  version = benchVersion;

  src = fetchFromGitHub {
    owner = "frappe";
    repo = "bench";
    rev = "v${benchVersion}";
    sha256 = benchSrcHash;
  };

  format = "pyproject";

  nativeBuildInputs = [ pythonRelaxDepsHook ];
  pythonRelaxDeps = [ "jinja2" "python-crontab" "semantic-version" ];

  buildInputs = [
    hatchling
  ];

  propagatedBuildInputs = [
    click
    gitpython
    honcho
    jinja2
    python-crontab
    requests
    semantic-version
    setuptools
    tomli
  ];
}
